@echo off
rem -----------------------------------------------------
rem Copyright (c): 2017, Huawei Tech. Co., Ltd.
rem FileName     : sslcert_env.bat
rem Version      : Gauss200 OLAP
rem Date         : 2017-08-29
rem Description  : This file is to configure environment variables of certifications.
rem -----------------------------------------------------

set sslcert_dir=%APPDATA%\postgresql

if not exist sslcert/client.crt (
    echo Failed to configure ssl envrionment: ./sslcert/client.crt not exists.
	goto exit_step
)
if not exist sslcert/client.key (
    echo Failed to configure ssl envrionment: sslcert/client.key not exists.
	goto exit_step
)
if not exist sslcert/client.key.cipher (
    echo Failed to configure ssl envrionment: sslcert/client.key.cipher not exists.
	goto exit_step
)
if not exist sslcert/client.key.rand  (
    echo Failed to configure ssl envrionment: sslcert/client.key.rand not exists.
	goto exit_step
)
if not exist sslcert/cacert.pem  (
    echo Failed to configure ssl envrionment: sslcert/cacert.pem not exists.
	goto exit_step
)

rem Here we have to use a "goto" statement to avoid brackets make "set /p" not working.
if exist %sslcert_dir% (goto remove_ssl_files)

:copy_certs
rem start to configure ssl certificate files.
md %sslcert_dir%
echo "%sslcert_dir%" created.

copy sslcert\client.crt          %sslcert_dir%\postgres.crt > nul
if "%errorlevel%" equ "0" (
    echo copying client.crt .............. done
    ) else (
    echo Failed to copy client.crt. 
    goto exit_step
    )

copy sslcert\client.key          %sslcert_dir%\postgres.key > nul
if "%errorlevel%" equ "0" (
    echo copying client.key .............. done
    ) else (
    echo Failed to copy client.key. 
    goto exit_step
    )


copy sslcert\client.key.cipher   %sslcert_dir%\postgres.key.cipher > nul
if "%errorlevel%" equ "0" (
    echo copying client.key.cipher ....... done
    ) else (
    echo Failed to copy client.key.cipher.
    goto exit_step
    )

copy sslcert\client.key.rand     %sslcert_dir%\postgres.key.rand > nul
if "%errorlevel%" equ "0" (
    echo copying client.key.rand ......... done
    ) else (
    echo Failed to copy client.key.rand.
    goto exit_step
    )

copy sslcert\cacert.pem          %sslcert_dir%\root.crt > nul
if "%errorlevel%" equ "0" (
    echo copying cacert.pem .............. done
    ) else (
    echo Failed to copy cacert.pem. 
    goto exit_step
    )

echo.
echo New certificate files are in folder "%sslcert_dir%".
echo.

echo If you are using JDBC with SSL, see manual for more informations.
echo All things done. 
echo.
goto exit_step

rem Confirm to remove certificate files already exist?
:remove_ssl_files
    echo WARNING: "%sslcert_dir%" already exists.
    SET /P del_ssldir=Do you want to remove it?^(y/n^)

    if "%del_ssldir%"=="y" (
        RD /S /Q "%sslcert_dir%"
        echo "%sslcert_dir%" removed.
        goto copy_certs
    ) else (
        echo Quit to configure SSL certificate files.
        goto exit_step
    )

:exit_step
rem Clean the variables we set.
SET del_ssldir=
pause